
#include <cstdio>
#include <vector>
#include <queue>
#include <algorithm>
using namespace std;

#define INF (1<<30)

int main(void){
	int n,r;
	scanf("%d %d", &n, &r);
	vector<vector<pair<int,int> > > edges(n+1);
	while(r--){
		int a,b,c;
		scanf("%d %d %d", &a, &b, &c);
		edges[a].push_back(make_pair(b,c));
		edges[b].push_back(make_pair(a,c));
	}
	vector<int> pot1(n+1,INF),pot2(n+1,INF);
	priority_queue<pair<int,int> > q;
	q.push(make_pair(-0,1));
	while(q.size()){
		int score = -q.top().first;
		int t     = q.top().second;
		q.pop();
		if(pot2[t] <= score || pot1[t] == score) continue;
		if(pot1[t] > score){
			pot1[t] = score;
		}else{
			pot2[t] = score;
		}
		for(int i=0;i<edges[t].size();i++)
			q.push(make_pair(-score-edges[t][i].second, edges[t][i].first));
	}
	printf("%d\n", pot2[n]);
	return 0;
}
